/*
 * watchdog.c
 *
 *  Created on: May 18, 2015
 *      Author: yango
 */

#include "LPC17xx.h"

#include "watchdog.h"


void Watchdog_init(uint32_t timeout)
{
#ifdef _USE_DEBUG_MESSAGES
    printf("Watchdog_init()\n");
#endif
    // Set the watchdog timer constant reload value
    LPC_WDT->WDTC = timeout * 256 * 4; // timeout value
    // Setup the Watchdog time operating mode in WDMOD register
    LPC_WDT->WDMOD = 0x3; // Watch dog enabled, reset disable , watchdog cleared by software.
    // Enable watchdow by writting 0xAA followed by 0x55 to WDFEED register
    // Reload the watchdog timer with the WDTC value.
    LPC_WDT->WDFEED = 0xAA;
    LPC_WDT->WDFEED = 0x55;
    NVIC_EnableIRQ(WDT_IRQn);
}

void Watchdog_pulse()
{
#ifdef _USE_DEBUG_MESSAGES
    printf("%s\n",__PRETTY_FUNCTION__);
#endif
    LPC_WDT->WDFEED = 0xAA;
    LPC_WDT->WDFEED = 0x55;
}

void WDT_IRQHandler(void)
{
// //LPC_WDT->WDMOD &= ~WDTOF; /* clear the time-out interrupt flag */
// LPC_WDT->WDMOD |= ( 0 << 2); /* clear the time-out interrupt flag */
    LPC_WDT->WDTC = 10000 * 256 * 4; // timeout value
    LPC_WDT->WDMOD = 0x3;
    LPC_WDT->WDFEED = 0xAA;
    LPC_WDT->WDFEED = 0x55;
    printf("watchdog!()!\n");
    return;
    if ( LPC_WDT->WDMOD & 1 << 2 )
    {
        // TODO: Wake up CPU!
        LPC_WDT->WDFEED = 0xAA;
        LPC_WDT->WDFEED = 0x55;
        LPC_WDT->WDMOD &= ~(1<< 3); // Set bit timeout to 0 othertime.
    }
}
