/*
 * kwp2000.h
 *
 *  Created on: May 30, 2015
 *      Author: yango
 */

#ifndef KWP2000_H_
#define KWP2000_H_

#include <stdint.h>
#include <stdarg.h>
#include "FreeRTOS.h"
#include "LPC17xx.h"
#include "semphr.h"
#include "type.h"
#include "printf.h"

#define KWP2000_MAX_DATA_RECV_SIZE 64



//P4: inter byte tester 5 - 20
static const uint32_t KWP2000_BYTE_DELAY_MS = 10;

// P3: from ecu response to new request 55 - 5000
#define ISORequestDelay 60

#define READ_ATTEMPTS 125


#define KEEP_ALIVE_SIZE 6


#define KWP2000_REQUEST_STATUS_SIZE 7

static const uint32_t KWP2000_PULSE_WAIT_MS = 25;
static const uint32_t KWP2000_RESPONSE_WAIT_MS = 75;

int32_t KWP2000_start(UART_ID uartId, uint8_t pulsePin);
int32_t KWP2000_connect(UART_ID uartId);
int32_t KWP2000_requestData(UART_ID uartId, char * outputBuffer );

#endif /* KWP2000_H_ */
