
// --- file led.h ---

/**
 * Simple led driver for LPC1769
 *
 * Daniel Zayas
 *
 * revision 1.0 2015-02-27
 */


#ifndef __UOC_LED_H
#define __UOC_LED_H

/** Initializes GPIO registers
 * @precondition any
 *
 * @return void
 */
void Led_init();

/** Puts led on
 * @precondition GPIO has been initialized with previous call led_init()
 *
 * @return void
 */
void Led_on();

/** Puts led off
 * @precondition GPIO has been initialized with previous call led_init()
 *
 * @return void
 */
void Led_off();

/** Toggles led status
 * @precondition GPIO has been initialized with previous call led_init()
 *
 * @return void
 */
void Led_toggle();


#endif
