/*
 * log.h
 *
 *  Created on: Mar 18, 2015
 *      Author: dzayas
 */

#ifndef LOG_H_
#define LOG_H_

#include <stdint.h>
#include "printf.h"


/* Private methods */



/* Public interface */


/** Initializes Log module
 * @precondition baudrate and uartId are correct
 *
 * @param uartId   UART number
 * @param baudrate       valid baudraute

 *
 * @return 0 in case of success, otherwise returns a negative value defined in ret.h
 */
int32_t Log_start(UART_ID uartId, uint32_t baudRate);


/** Logs a message through UART
 * @precondition Log module has been intialized
 *
 * @param uartId   UART number
 * @param baudrate       valid baudraute

 *
 * @return 0 in case of success, otherwise returns a negative value defined in ret.h
 */
int32_t Log_log(uint8_t *strBuffer);



#endif /* LOG_H_ */
