/*
 * printf.h
 *
 *  Created on: 16/3/2015
 *      Author: dzayas
 */



#ifndef PRINTF_H_
#define PRINTF_H_

#include <stdint.h>
#include <stdarg.h>
#include "FreeRTOS.h"
#include "LPC17xx.h"
#include "semphr.h"
#include "type.h"












//int32_t PrintF_scan2(UART_ID uartId, int8_t *strText, ...);


/* Public interface */

/** Initializes a UART
 * @precondition baudrate and uartId are correct
 *
 * @param uartId   UART number
 * @param baudrate       valid baudraute

 *
 * @return 0 in case of success, otherwise returns a negative value defined in ret.h
 */
int32_t PrintF_start(UART_ID uartId, uint32_t baudRate);


/** Sends strText through the UART uartId
 *
 * @param uartId   UART number
 * @param strFormat  pointer to a format string like standar printf
 * @param ... list of variables
 *
 * @return 0 in case of success, otherwise returns a negative value defined in ret.h
 */
int32_t PrintF_print(UART_ID uartId, const char *strText, ...)  __attribute__((__long_call__));

/** Reads data from UART
 * @precondition UART uartId has been initialized and is not UART2
 *
 * @param uartId   UART number
 * @param buffer   pointer to a valid memory region
 * @param delayMs  number of milliseconds before read

 *
 * @return number of bytes readed in case of success, otherwise returns a negative value defined in ret.h
 */
int32_t PrintF_scan(UART_ID uartId, char *buffer, uint32_t delayMs );



#endif /* PRINTF_H_ */
