#include "LPC17xx.h"
#include "led.h"

/* The bit of port 0 that the LPCXpresso LPC13xx LED is connected. */
#define mainLED_BIT 						 22
unsigned long ulLEDState;





void Led_init()
{
    /* Initialise P0_22 for the LED. */
    /* Clear bits 12 and 11 on PINSEL1 */
    LPC_PINCON->PINSEL1	&= ( ~( 3 << 12 ) );
    /* Data direction 1 -> OUT */
    LPC_GPIO0->FIODIR |= ( 1 << mainLED_BIT );
    //LPC_GPIO0->FIOMASK |= ( 1 << mainLED_BIT ) ;
}




void Led_on()
{
    LPC_GPIO0->FIOSET =  1 << mainLED_BIT  ;
    /* Turn the LED off if it was on, and on if it was off. */
}

void Led_off()
{
    /* Turn the LED off if it was on, and on if it was off. */
    LPC_GPIO0->FIOCLR = 1 << mainLED_BIT ;
}

void Led_toggle()
{
    /* Obtain the current P0 state. */
    ulLEDState = LPC_GPIO0->FIOPIN;
    /* Turn the LED off if it was on, and on if it was off. */
    LPC_GPIO0->FIOCLR = ulLEDState & ( 1 << mainLED_BIT );
    LPC_GPIO0->FIOSET = ( ( ~ulLEDState ) & ( 1 << mainLED_BIT ) );
}
