/*
 * timer.c
 *
 *  Created on: Mar 18, 2015
 *      Author: dzayas
 */

#include <stdint.h>

#include "LPC17xx.h"
#include "FreeRTOS.h"
#include "type.h"
#include "semphr.h"


//TODO poner esto en un array para soportar más de un timer
static xSemaphoreHandle mutexTimer0;
static uint8_t timer0Initialized = 0;

void Timer_sleepMs(uint8_t numTimer, uint32_t delayInMs)
{
    //NOTA: sólo soportamos timer0 de momento
    if( 0 == delayInMs )
    {
        return;
    }
    if ( TIMER0 == numTimer )
    {
        if( 0 == timer0Initialized )
        {
            mutexTimer0 = xSemaphoreCreateMutex();
            timer0Initialized = 1;
        }
        if( pdTRUE !=  xSemaphoreTake( mutexTimer0  , portMAX_DELAY) )
        {
            return ;
        }
        LPC_TIM0->TCR = 0x02;		// Reset timer
        LPC_TIM0->PR  = 0x00;		// Preescaler a 0
        //uint32_t tmp = (SystemCoreClock / 4) / (1000 / delayInMs);
        //printf("tmp = %u\n",tmp);
        uint32_t tmp = SystemCoreClock * delayInMs;
        tmp = tmp / 4000;
//	printf("tmp2 = %u\n",tmp);
        LPC_TIM0->MR0 =  tmp ;  //Calculo delay (SystemCoreClock * delayInMs) / 4000;  //
        if ( 0 == LPC_TIM0->MR0 )
        {
            //ERROR
            //TODO devolver código error
            printf("ERROR TIMER!\n");
            xSemaphoreGive(mutexTimer0);
            return;
        }
        LPC_TIM0->IR  = 0xff;		//Clear de interrupciones
        LPC_TIM0->MCR = 0x04;		//Parar timer con MATCH. Cuando suceda pone a 0 TCR.0
        LPC_TIM0->TCR = 0x01;		//Empezar a operar
        //Espera activa
        while (0 != (LPC_TIM0->TCR & 0x01))
        {
            //esperar
        }
        xSemaphoreGive(mutexTimer0);
    }
}



